/*
Authorization Service API v. 1.0

<a href='https://cern.service-now.com/service-portal?id=privacy_policy&se=SSO-Service&notice=resources'>Privacy notice</a>

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package authzapiv1

import (
	"encoding/json"
)

// checks if the AuditOperationDetailsEnvelope type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &AuditOperationDetailsEnvelope{}

// AuditOperationDetailsEnvelope struct for AuditOperationDetailsEnvelope
type AuditOperationDetailsEnvelope struct {
	RequestId NullableString         `json:"request_id,omitempty"`
	Message   NullableString         `json:"message,omitempty"`
	Data      *AuditOperationDetails `json:"data,omitempty"`
}

// NewAuditOperationDetailsEnvelope instantiates a new AuditOperationDetailsEnvelope object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewAuditOperationDetailsEnvelope() *AuditOperationDetailsEnvelope {
	this := AuditOperationDetailsEnvelope{}
	return &this
}

// NewAuditOperationDetailsEnvelopeWithDefaults instantiates a new AuditOperationDetailsEnvelope object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewAuditOperationDetailsEnvelopeWithDefaults() *AuditOperationDetailsEnvelope {
	this := AuditOperationDetailsEnvelope{}
	return &this
}

// GetRequestId returns the RequestId field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *AuditOperationDetailsEnvelope) GetRequestId() string {
	if o == nil || IsNil(o.RequestId.Get()) {
		var ret string
		return ret
	}
	return *o.RequestId.Get()
}

// GetRequestIdOk returns a tuple with the RequestId field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *AuditOperationDetailsEnvelope) GetRequestIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.RequestId.Get(), o.RequestId.IsSet()
}

// HasRequestId returns a boolean if a field has been set.
func (o *AuditOperationDetailsEnvelope) HasRequestId() bool {
	if o != nil && o.RequestId.IsSet() {
		return true
	}

	return false
}

// SetRequestId gets a reference to the given NullableString and assigns it to the RequestId field.
func (o *AuditOperationDetailsEnvelope) SetRequestId(v string) {
	o.RequestId.Set(&v)
}

// SetRequestIdNil sets the value for RequestId to be an explicit nil
func (o *AuditOperationDetailsEnvelope) SetRequestIdNil() {
	o.RequestId.Set(nil)
}

// UnsetRequestId ensures that no value is present for RequestId, not even an explicit nil
func (o *AuditOperationDetailsEnvelope) UnsetRequestId() {
	o.RequestId.Unset()
}

// GetMessage returns the Message field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *AuditOperationDetailsEnvelope) GetMessage() string {
	if o == nil || IsNil(o.Message.Get()) {
		var ret string
		return ret
	}
	return *o.Message.Get()
}

// GetMessageOk returns a tuple with the Message field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *AuditOperationDetailsEnvelope) GetMessageOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.Message.Get(), o.Message.IsSet()
}

// HasMessage returns a boolean if a field has been set.
func (o *AuditOperationDetailsEnvelope) HasMessage() bool {
	if o != nil && o.Message.IsSet() {
		return true
	}

	return false
}

// SetMessage gets a reference to the given NullableString and assigns it to the Message field.
func (o *AuditOperationDetailsEnvelope) SetMessage(v string) {
	o.Message.Set(&v)
}

// SetMessageNil sets the value for Message to be an explicit nil
func (o *AuditOperationDetailsEnvelope) SetMessageNil() {
	o.Message.Set(nil)
}

// UnsetMessage ensures that no value is present for Message, not even an explicit nil
func (o *AuditOperationDetailsEnvelope) UnsetMessage() {
	o.Message.Unset()
}

// GetData returns the Data field value if set, zero value otherwise.
func (o *AuditOperationDetailsEnvelope) GetData() AuditOperationDetails {
	if o == nil || IsNil(o.Data) {
		var ret AuditOperationDetails
		return ret
	}
	return *o.Data
}

// GetDataOk returns a tuple with the Data field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AuditOperationDetailsEnvelope) GetDataOk() (*AuditOperationDetails, bool) {
	if o == nil || IsNil(o.Data) {
		return nil, false
	}
	return o.Data, true
}

// HasData returns a boolean if a field has been set.
func (o *AuditOperationDetailsEnvelope) HasData() bool {
	if o != nil && !IsNil(o.Data) {
		return true
	}

	return false
}

// SetData gets a reference to the given AuditOperationDetails and assigns it to the Data field.
func (o *AuditOperationDetailsEnvelope) SetData(v AuditOperationDetails) {
	o.Data = &v
}

func (o AuditOperationDetailsEnvelope) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o AuditOperationDetailsEnvelope) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if o.RequestId.IsSet() {
		toSerialize["request_id"] = o.RequestId.Get()
	}
	if o.Message.IsSet() {
		toSerialize["message"] = o.Message.Get()
	}
	if !IsNil(o.Data) {
		toSerialize["data"] = o.Data
	}
	return toSerialize, nil
}

type NullableAuditOperationDetailsEnvelope struct {
	value *AuditOperationDetailsEnvelope
	isSet bool
}

func (v NullableAuditOperationDetailsEnvelope) Get() *AuditOperationDetailsEnvelope {
	return v.value
}

func (v *NullableAuditOperationDetailsEnvelope) Set(val *AuditOperationDetailsEnvelope) {
	v.value = val
	v.isSet = true
}

func (v NullableAuditOperationDetailsEnvelope) IsSet() bool {
	return v.isSet
}

func (v *NullableAuditOperationDetailsEnvelope) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableAuditOperationDetailsEnvelope(val *AuditOperationDetailsEnvelope) *NullableAuditOperationDetailsEnvelope {
	return &NullableAuditOperationDetailsEnvelope{value: val, isSet: true}
}

func (v NullableAuditOperationDetailsEnvelope) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableAuditOperationDetailsEnvelope) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
